package in.ashokit;

public class CustomerTest  {
	
	
	int balance=10000;
	
	synchronized void withdraw(int amount){
		
		System.out.println("With Draw API");
		if(this.balance < amount)
		{
			
		System.out.println("Less Balance ...Waiting for Deposit");
		
		    try {
					wait();
			}catch(Exception e){}
		}
		this.balance=this.balance-amount;
		System.out.println("WithDraw is Completed");
		
	}
	synchronized void deposit(int amount){
		System.out.println("Deposit Section");
		this.balance=this.balance+amount;
		System.out.println("Deposit Completed");
		notify();
	}
	

	
	
	public static void main(String args[]){
		
		final CustomerTest c = new CustomerTest();
		
		new Thread(){
			
			public void run(){
				c.withdraw(15000);
			}
		}.start();
		
		
		try {
			Thread.sleep(10000);
		}catch(InterruptedException e) {  }
		
		
		
		new Thread(){
			
			public void run(){
				c.deposit(10000);
			}
		}.start();
		
	}
	
}
/* Output

With Draw API
Less Balance ...Waiting for Deposit
Deposit Section
Deposit Completed
WithDraw is Completed


*/